package ch.inf3.indexation.entitymanager;

import java.io.IOException;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;
import javax.inject.Inject;
import org.apache.solr.client.solrj.impl.HttpSolrClient;
import org.eclipse.microprofile.config.inject.ConfigProperty;

@ApplicationScoped
public class SolrClientProducer {

    @Inject
    @ConfigProperty(name = "solr.url")
    private String solrUrl;

    @Produces
    public HttpSolrClient createSolrClient() {
        return new HttpSolrClient.Builder(solrUrl).build();
    }

    public void close(HttpSolrClient solrClient) throws IOException {
        solrClient.close();
    }
}
