package ch.inf3.indexation.importer;

import ch.inf3.indexation.model.Bookmark;
import java.time.Instant;
import java.util.Date;
import javax.json.JsonNumber;
import javax.json.JsonObject;

public class BookmarkJsonPage {

    private final String prefix;
    private final JsonObject entry;

    public BookmarkJsonPage(String prefix, JsonObject entry) {
        this.entry = entry;
        this.prefix = prefix;
    }

    private Date dateFromEpochMicro(JsonNumber epochMicro) {
        return Date.from(Instant.ofEpochMilli(epochMicro.longValueExact() / 1000));
    }

    public String getGuid() {
        return entry.getString("guid");
    }

    public Bookmark toEntity() {
        Bookmark t = new Bookmark();

        updateEntity(t);

        return t;
    }

    public void updateEntity(Bookmark t) {
        t.setGuid(entry.getString("guid"));
        t.setTitle(entry.getString("title"));
        t.setIndex(entry.getInt("index"));
        t.setDateAdded(dateFromEpochMicro(entry.getJsonNumber("dateAdded")));
        t.setLastModified(dateFromEpochMicro(entry.getJsonNumber("lastModified")));
        t.setId(entry.getInt("id"));
        t.setTypeCode(entry.getInt("typeCode"));
        t.setType(entry.getString("type"));
        t.setUri(entry.getString("uri"));

        t.setInternalPrefix(prefix);
    }
}
